// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "PWAL.h"
#include "PWALI.h"

// Average log score
SCORE PWAL::ALScore(const FCOUNT fcCountsA[MAX_ALPHA],
  const FCOUNT fcCountsB[MAX_ALPHA])
	{
	double dSum = 0.0;

// Loop-unrolled code generated by code.py
	dSum += fcCountsA[0]*fcCountsB[0]* 3.9291227;
	dSum += fcCountsA[0]*fcCountsB[1]*-0.4085055;
	dSum += fcCountsA[0]*fcCountsB[2]*-1.7534361;
	dSum += fcCountsA[0]*fcCountsB[3]*-0.8638814;
	dSum += fcCountsA[0]*fcCountsB[4]*-2.2100510;
	dSum += fcCountsA[0]*fcCountsB[5]* 0.1595946;
	dSum += fcCountsA[0]*fcCountsB[6]*-1.6251467;
	dSum += fcCountsA[0]*fcCountsB[7]*-1.3218107;
	dSum += fcCountsA[0]*fcCountsB[8]*-0.7340126;
	dSum += fcCountsA[0]*fcCountsB[9]*-1.4645883;
	dSum += fcCountsA[0]*fcCountsB[10]*-0.9352672;
	dSum += fcCountsA[0]*fcCountsB[11]*-1.5307145;
	dSum += fcCountsA[0]*fcCountsB[12]*-0.8142625;
	dSum += fcCountsA[0]*fcCountsB[13]*-0.8040186;
	dSum += fcCountsA[0]*fcCountsB[14]*-1.4135002;
	dSum += fcCountsA[0]*fcCountsB[15]* 1.1157587;
	dSum += fcCountsA[0]*fcCountsB[16]*-0.0453604;
	dSum += fcCountsA[0]*fcCountsB[17]*-0.1894263;
	dSum += fcCountsA[0]*fcCountsB[18]*-2.5268877;
	dSum += fcCountsA[0]*fcCountsB[19]*-1.7640114;
	dSum += fcCountsA[1]*fcCountsB[0]*-0.4085055;
	dSum += fcCountsA[1]*fcCountsB[1]* 8.5821137;
	dSum += fcCountsA[1]*fcCountsB[2]*-3.4599789;
	dSum += fcCountsA[1]*fcCountsB[3]*-3.6124845;
	dSum += fcCountsA[1]*fcCountsB[4]*-2.3754732;
	dSum += fcCountsA[1]*fcCountsB[5]*-2.5004092;
	dSum += fcCountsA[1]*fcCountsB[6]*-2.9878347;
	dSum += fcCountsA[1]*fcCountsB[7]*-1.2276634;
	dSum += fcCountsA[1]*fcCountsB[8]*-3.0363307;
	dSum += fcCountsA[1]*fcCountsB[9]*-1.2774693;
	dSum += fcCountsA[1]*fcCountsB[10]*-1.4198414;
	dSum += fcCountsA[1]*fcCountsB[11]*-2.6597505;
	dSum += fcCountsA[1]*fcCountsB[12]*-2.7951789;
	dSum += fcCountsA[1]*fcCountsB[13]*-2.9019066;
	dSum += fcCountsA[1]*fcCountsB[14]*-3.3892226;
	dSum += fcCountsA[1]*fcCountsB[15]*-0.8749933;
	dSum += fcCountsA[1]*fcCountsB[16]*-0.8666503;
	dSum += fcCountsA[1]*fcCountsB[17]*-0.8076761;
	dSum += fcCountsA[1]*fcCountsB[18]*-2.3041298;
	dSum += fcCountsA[1]*fcCountsB[19]*-2.4071280;
	dSum += fcCountsA[2]*fcCountsB[0]*-1.7534361;
	dSum += fcCountsA[2]*fcCountsB[1]*-3.4599789;
	dSum += fcCountsA[2]*fcCountsB[2]* 5.7742415;
	dSum += fcCountsA[2]*fcCountsB[3]* 1.5103065;
	dSum += fcCountsA[2]*fcCountsB[4]*-3.4838591;
	dSum += fcCountsA[2]*fcCountsB[5]*-1.3135186;
	dSum += fcCountsA[2]*fcCountsB[6]*-1.1189064;
	dSum += fcCountsA[2]*fcCountsB[7]*-3.1211538;
	dSum += fcCountsA[2]*fcCountsB[8]*-0.7018159;
	dSum += fcCountsA[2]*fcCountsB[9]*-3.6056501;
	dSum += fcCountsA[2]*fcCountsB[10]*-3.0585226;
	dSum += fcCountsA[2]*fcCountsB[11]* 1.2716982;
	dSum += fcCountsA[2]*fcCountsB[12]*-1.4801045;
	dSum += fcCountsA[2]*fcCountsB[13]*-0.3133794;
	dSum += fcCountsA[2]*fcCountsB[14]*-1.6057788;
	dSum += fcCountsA[2]*fcCountsB[15]*-0.2610307;
	dSum += fcCountsA[2]*fcCountsB[16]*-1.0507031;
	dSum += fcCountsA[2]*fcCountsB[17]*-3.1426396;
	dSum += fcCountsA[2]*fcCountsB[18]*-4.2143008;
	dSum += fcCountsA[2]*fcCountsB[19]*-3.0649574;
	dSum += fcCountsA[3]*fcCountsB[0]*-0.8638814;
	dSum += fcCountsA[3]*fcCountsB[1]*-3.6124845;
	dSum += fcCountsA[3]*fcCountsB[2]* 1.5103065;
	dSum += fcCountsA[3]*fcCountsB[3]* 4.9028325;
	dSum += fcCountsA[3]*fcCountsB[4]*-3.1924256;
	dSum += fcCountsA[3]*fcCountsB[5]*-2.1101782;
	dSum += fcCountsA[3]*fcCountsB[6]*-0.1176671;
	dSum += fcCountsA[3]*fcCountsB[7]*-3.1943606;
	dSum += fcCountsA[3]*fcCountsB[8]* 0.7753388;
	dSum += fcCountsA[3]*fcCountsB[9]*-2.8464843;
	dSum += fcCountsA[3]*fcCountsB[10]*-1.9980267;
	dSum += fcCountsA[3]*fcCountsB[11]*-0.2680095;
	dSum += fcCountsA[3]*fcCountsB[12]*-1.1161720;
	dSum += fcCountsA[3]*fcCountsB[13]* 1.8546363;
	dSum += fcCountsA[3]*fcCountsB[14]*-0.1153890;
	dSum += fcCountsA[3]*fcCountsB[15]*-0.1469171;
	dSum += fcCountsA[3]*fcCountsB[16]*-0.8632508;
	dSum += fcCountsA[3]*fcCountsB[17]*-2.4422836;
	dSum += fcCountsA[3]*fcCountsB[18]*-2.8354498;
	dSum += fcCountsA[3]*fcCountsB[19]*-2.0204641;
	dSum += fcCountsA[4]*fcCountsB[0]*-2.2100510;
	dSum += fcCountsA[4]*fcCountsB[1]*-2.3754732;
	dSum += fcCountsA[4]*fcCountsB[2]*-3.4838591;
	dSum += fcCountsA[4]*fcCountsB[3]*-3.1924256;
	dSum += fcCountsA[4]*fcCountsB[4]* 6.0460842;
	dSum += fcCountsA[4]*fcCountsB[5]*-3.1073550;
	dSum += fcCountsA[4]*fcCountsB[6]*-1.2341594;
	dSum += fcCountsA[4]*fcCountsB[7]*-0.1608781;
	dSum += fcCountsA[4]*fcCountsB[8]*-3.0786762;
	dSum += fcCountsA[4]*fcCountsB[9]* 0.4147808;
	dSum += fcCountsA[4]*fcCountsB[10]* 0.0125860;
	dSum += fcCountsA[4]*fcCountsB[11]*-2.9940093;
	dSum += fcCountsA[4]*fcCountsB[12]*-3.5972941;
	dSum += fcCountsA[4]*fcCountsB[13]*-3.1643941;
	dSum += fcCountsA[4]*fcCountsB[14]*-2.7863475;
	dSum += fcCountsA[4]*fcCountsB[15]*-2.3690224;
	dSum += fcCountsA[4]*fcCountsB[16]*-2.1076281;
	dSum += fcCountsA[4]*fcCountsB[17]*-0.8490293;
	dSum += fcCountsA[4]*fcCountsB[18]* 0.9175567;
	dSum += fcCountsA[4]*fcCountsB[19]* 2.9391278;
	dSum += fcCountsA[5]*fcCountsB[0]* 0.1595946;
	dSum += fcCountsA[5]*fcCountsB[1]*-2.5004092;
	dSum += fcCountsA[5]*fcCountsB[2]*-1.3135186;
	dSum += fcCountsA[5]*fcCountsB[3]*-2.1101782;
	dSum += fcCountsA[5]*fcCountsB[4]*-3.1073550;
	dSum += fcCountsA[5]*fcCountsB[5]* 5.5632681;
	dSum += fcCountsA[5]*fcCountsB[6]*-2.0408782;
	dSum += fcCountsA[5]*fcCountsB[7]*-3.7248922;
	dSum += fcCountsA[5]*fcCountsB[8]*-1.5279501;
	dSum += fcCountsA[5]*fcCountsB[9]*-3.6269590;
	dSum += fcCountsA[5]*fcCountsB[10]*-2.6765993;
	dSum += fcCountsA[5]*fcCountsB[11]*-0.4227577;
	dSum += fcCountsA[5]*fcCountsB[12]*-2.1335446;
	dSum += fcCountsA[5]*fcCountsB[13]*-1.7851608;
	dSum += fcCountsA[5]*fcCountsB[14]*-2.3041088;
	dSum += fcCountsA[5]*fcCountsB[15]*-0.2924989;
	dSum += fcCountsA[5]*fcCountsB[16]*-1.5753783;
	dSum += fcCountsA[5]*fcCountsB[17]*-3.1387434;
	dSum += fcCountsA[5]*fcCountsB[18]*-2.4914919;
	dSum += fcCountsA[5]*fcCountsB[19]*-3.0397666;
	dSum += fcCountsA[6]*fcCountsB[0]*-1.6251467;
	dSum += fcCountsA[6]*fcCountsB[1]*-2.9878347;
	dSum += fcCountsA[6]*fcCountsB[2]*-1.1189064;
	dSum += fcCountsA[6]*fcCountsB[3]*-0.1176671;
	dSum += fcCountsA[6]*fcCountsB[4]*-1.2341594;
	dSum += fcCountsA[6]*fcCountsB[5]*-2.0408782;
	dSum += fcCountsA[6]*fcCountsB[6]* 7.5110586;
	dSum += fcCountsA[6]*fcCountsB[7]*-3.2315662;
	dSum += fcCountsA[6]*fcCountsB[8]*-0.7210228;
	dSum += fcCountsA[6]*fcCountsB[9]*-2.7867297;
	dSum += fcCountsA[6]*fcCountsB[10]*-1.5512694;
	dSum += fcCountsA[6]*fcCountsB[11]* 0.5784952;
	dSum += fcCountsA[6]*fcCountsB[12]*-2.1609100;
	dSum += fcCountsA[6]*fcCountsB[13]* 0.4480397;
	dSum += fcCountsA[6]*fcCountsB[14]*-0.2498638;
	dSum += fcCountsA[6]*fcCountsB[15]*-0.8815769;
	dSum += fcCountsA[6]*fcCountsB[16]*-1.6859019;
	dSum += fcCountsA[6]*fcCountsB[17]*-3.1174802;
	dSum += fcCountsA[6]*fcCountsB[18]*-2.3421789;
	dSum += fcCountsA[6]*fcCountsB[19]* 1.6926313;
	dSum += fcCountsA[7]*fcCountsB[0]*-1.3218107;
	dSum += fcCountsA[7]*fcCountsB[1]*-1.2276634;
	dSum += fcCountsA[7]*fcCountsB[2]*-3.1211538;
	dSum += fcCountsA[7]*fcCountsB[3]*-3.1943606;
	dSum += fcCountsA[7]*fcCountsB[4]*-0.1608781;
	dSum += fcCountsA[7]*fcCountsB[5]*-3.7248922;
	dSum += fcCountsA[7]*fcCountsB[6]*-3.2315662;
	dSum += fcCountsA[7]*fcCountsB[7]* 3.9985064;
	dSum += fcCountsA[7]*fcCountsB[8]*-2.6701387;
	dSum += fcCountsA[7]*fcCountsB[9]* 1.5216084;
	dSum += fcCountsA[7]*fcCountsB[10]* 1.1267944;
	dSum += fcCountsA[7]*fcCountsB[11]*-3.2170409;
	dSum += fcCountsA[7]*fcCountsB[12]*-2.7566667;
	dSum += fcCountsA[7]*fcCountsB[13]*-2.7696385;
	dSum += fcCountsA[7]*fcCountsB[14]*-2.9902437;
	dSum += fcCountsA[7]*fcCountsB[15]*-2.3481785;
	dSum += fcCountsA[7]*fcCountsB[16]*-0.7175874;
	dSum += fcCountsA[7]*fcCountsB[17]* 2.5470463;
	dSum += fcCountsA[7]*fcCountsB[18]*-2.5805492;
	dSum += fcCountsA[7]*fcCountsB[19]*-1.3313680;
	dSum += fcCountsA[8]*fcCountsB[0]*-0.7340126;
	dSum += fcCountsA[8]*fcCountsB[1]*-3.0363307;
	dSum += fcCountsA[8]*fcCountsB[2]*-0.7018159;
	dSum += fcCountsA[8]*fcCountsB[3]* 0.7753388;
	dSum += fcCountsA[8]*fcCountsB[4]*-3.0786762;
	dSum += fcCountsA[8]*fcCountsB[5]*-1.5279501;
	dSum += fcCountsA[8]*fcCountsB[6]*-0.7210228;
	dSum += fcCountsA[8]*fcCountsB[7]*-2.6701387;
	dSum += fcCountsA[8]*fcCountsB[8]* 4.5045502;
	dSum += fcCountsA[8]*fcCountsB[9]*-2.4468137;
	dSum += fcCountsA[8]*fcCountsB[10]*-1.3547438;
	dSum += fcCountsA[8]*fcCountsB[11]*-0.1790200;
	dSum += fcCountsA[8]*fcCountsB[12]*-1.0136313;
	dSum += fcCountsA[8]*fcCountsB[13]* 1.2725733;
	dSum += fcCountsA[8]*fcCountsB[14]* 2.1087374;
	dSum += fcCountsA[8]*fcCountsB[15]*-0.2034464;
	dSum += fcCountsA[8]*fcCountsB[16]*-0.6695567;
	dSum += fcCountsA[8]*fcCountsB[17]*-2.2623551;
	dSum += fcCountsA[8]*fcCountsB[18]*-2.9564357;
	dSum += fcCountsA[8]*fcCountsB[19]*-1.8200362;
	dSum += fcCountsA[9]*fcCountsB[0]*-1.4645883;
	dSum += fcCountsA[9]*fcCountsB[1]*-1.2774693;
	dSum += fcCountsA[9]*fcCountsB[2]*-3.6056501;
	dSum += fcCountsA[9]*fcCountsB[3]*-2.8464843;
	dSum += fcCountsA[9]*fcCountsB[4]* 0.4147808;
	dSum += fcCountsA[9]*fcCountsB[5]*-3.6269590;
	dSum += fcCountsA[9]*fcCountsB[6]*-2.7867297;
	dSum += fcCountsA[9]*fcCountsB[7]* 1.5216084;
	dSum += fcCountsA[9]*fcCountsB[8]*-2.4468137;
	dSum += fcCountsA[9]*fcCountsB[9]* 3.8494323;
	dSum += fcCountsA[9]*fcCountsB[10]* 1.9917587;
	dSum += fcCountsA[9]*fcCountsB[11]*-3.3789193;
	dSum += fcCountsA[9]*fcCountsB[12]*-2.8600700;
	dSum += fcCountsA[9]*fcCountsB[13]*-2.1339056;
	dSum += fcCountsA[9]*fcCountsB[14]*-2.1545730;
	dSum += fcCountsA[9]*fcCountsB[15]*-2.4426147;
	dSum += fcCountsA[9]*fcCountsB[16]*-1.1974854;
	dSum += fcCountsA[9]*fcCountsB[17]* 0.7884477;
	dSum += fcCountsA[9]*fcCountsB[18]*-1.6318918;
	dSum += fcCountsA[9]*fcCountsB[19]*-1.0620664;
	dSum += fcCountsA[10]*fcCountsB[0]*-0.9352672;
	dSum += fcCountsA[10]*fcCountsB[1]*-1.4198414;
	dSum += fcCountsA[10]*fcCountsB[2]*-3.0585226;
	dSum += fcCountsA[10]*fcCountsB[3]*-1.9980267;
	dSum += fcCountsA[10]*fcCountsB[4]* 0.0125860;
	dSum += fcCountsA[10]*fcCountsB[5]*-2.6765993;
	dSum += fcCountsA[10]*fcCountsB[6]*-1.5512694;
	dSum += fcCountsA[10]*fcCountsB[7]* 1.1267944;
	dSum += fcCountsA[10]*fcCountsB[8]*-1.3547438;
	dSum += fcCountsA[10]*fcCountsB[9]* 1.9917587;
	dSum += fcCountsA[10]*fcCountsB[10]* 5.3926354;
	dSum += fcCountsA[10]*fcCountsB[11]*-2.1508581;
	dSum += fcCountsA[10]*fcCountsB[12]*-2.4764357;
	dSum += fcCountsA[10]*fcCountsB[13]*-0.4209636;
	dSum += fcCountsA[10]*fcCountsB[14]*-1.3671297;
	dSum += fcCountsA[10]*fcCountsB[15]*-1.4808749;
	dSum += fcCountsA[10]*fcCountsB[16]*-0.6662985;
	dSum += fcCountsA[10]*fcCountsB[17]* 0.6872398;
	dSum += fcCountsA[10]*fcCountsB[18]*-1.4248085;
	dSum += fcCountsA[10]*fcCountsB[19]*-0.9948761;
	dSum += fcCountsA[11]*fcCountsB[0]*-1.5307145;
	dSum += fcCountsA[11]*fcCountsB[1]*-2.6597505;
	dSum += fcCountsA[11]*fcCountsB[2]* 1.2716982;
	dSum += fcCountsA[11]*fcCountsB[3]*-0.2680095;
	dSum += fcCountsA[11]*fcCountsB[4]*-2.9940093;
	dSum += fcCountsA[11]*fcCountsB[5]*-0.4227577;
	dSum += fcCountsA[11]*fcCountsB[6]* 0.5784952;
	dSum += fcCountsA[11]*fcCountsB[7]*-3.2170409;
	dSum += fcCountsA[11]*fcCountsB[8]*-0.1790200;
	dSum += fcCountsA[11]*fcCountsB[9]*-3.3789193;
	dSum += fcCountsA[11]*fcCountsB[10]*-2.1508581;
	dSum += fcCountsA[11]*fcCountsB[11]* 5.6532379;
	dSum += fcCountsA[11]*fcCountsB[12]*-2.0003828;
	dSum += fcCountsA[11]*fcCountsB[13]* 0.0016832;
	dSum += fcCountsA[11]*fcCountsB[14]*-0.4397837;
	dSum += fcCountsA[11]*fcCountsB[15]* 0.6009010;
	dSum += fcCountsA[11]*fcCountsB[16]*-0.0460924;
	dSum += fcCountsA[11]*fcCountsB[17]*-2.8763484;
	dSum += fcCountsA[11]*fcCountsB[18]*-3.6959279;
	dSum += fcCountsA[11]*fcCountsB[19]*-2.0817604;
	dSum += fcCountsA[12]*fcCountsB[0]*-0.8142625;
	dSum += fcCountsA[12]*fcCountsB[1]*-2.7951789;
	dSum += fcCountsA[12]*fcCountsB[2]*-1.4801045;
	dSum += fcCountsA[12]*fcCountsB[3]*-1.1161720;
	dSum += fcCountsA[12]*fcCountsB[4]*-3.5972941;
	dSum += fcCountsA[12]*fcCountsB[5]*-2.1335446;
	dSum += fcCountsA[12]*fcCountsB[6]*-2.1609100;
	dSum += fcCountsA[12]*fcCountsB[7]*-2.7566667;
	dSum += fcCountsA[12]*fcCountsB[8]*-1.0136313;
	dSum += fcCountsA[12]*fcCountsB[9]*-2.8600700;
	dSum += fcCountsA[12]*fcCountsB[10]*-2.4764357;
	dSum += fcCountsA[12]*fcCountsB[11]*-2.0003828;
	dSum += fcCountsA[12]*fcCountsB[12]* 7.3645949;
	dSum += fcCountsA[12]*fcCountsB[13]*-1.2819462;
	dSum += fcCountsA[12]*fcCountsB[14]*-2.1085762;
	dSum += fcCountsA[12]*fcCountsB[15]*-0.8089802;
	dSum += fcCountsA[12]*fcCountsB[16]*-1.0752829;
	dSum += fcCountsA[12]*fcCountsB[17]*-2.3487055;
	dSum += fcCountsA[12]*fcCountsB[18]*-3.6541846;
	dSum += fcCountsA[12]*fcCountsB[19]*-2.9197736;
	dSum += fcCountsA[13]*fcCountsB[0]*-0.8040186;
	dSum += fcCountsA[13]*fcCountsB[1]*-2.9019066;
	dSum += fcCountsA[13]*fcCountsB[2]*-0.3133794;
	dSum += fcCountsA[13]*fcCountsB[3]* 1.8546363;
	dSum += fcCountsA[13]*fcCountsB[4]*-3.1643941;
	dSum += fcCountsA[13]*fcCountsB[5]*-1.7851608;
	dSum += fcCountsA[13]*fcCountsB[6]* 0.4480397;
	dSum += fcCountsA[13]*fcCountsB[7]*-2.7696385;
	dSum += fcCountsA[13]*fcCountsB[8]* 1.2725733;
	dSum += fcCountsA[13]*fcCountsB[9]*-2.1339056;
	dSum += fcCountsA[13]*fcCountsB[10]*-0.4209636;
	dSum += fcCountsA[13]*fcCountsB[11]* 0.0016832;
	dSum += fcCountsA[13]*fcCountsB[12]*-1.2819462;
	dSum += fcCountsA[13]*fcCountsB[13]* 5.2851356;
	dSum += fcCountsA[13]*fcCountsB[14]* 0.9827740;
	dSum += fcCountsA[13]*fcCountsB[15]*-0.1011365;
	dSum += fcCountsA[13]*fcCountsB[16]*-0.6753267;
	dSum += fcCountsA[13]*fcCountsB[17]*-2.1983822;
	dSum += fcCountsA[13]*fcCountsB[18]*-1.9464942;
	dSum += fcCountsA[13]*fcCountsB[19]*-1.4210626;
	dSum += fcCountsA[14]*fcCountsB[0]*-1.4135002;
	dSum += fcCountsA[14]*fcCountsB[1]*-3.3892226;
	dSum += fcCountsA[14]*fcCountsB[2]*-1.6057788;
	dSum += fcCountsA[14]*fcCountsB[3]*-0.1153890;
	dSum += fcCountsA[14]*fcCountsB[4]*-2.7863475;
	dSum += fcCountsA[14]*fcCountsB[5]*-2.3041088;
	dSum += fcCountsA[14]*fcCountsB[6]*-0.2498638;
	dSum += fcCountsA[14]*fcCountsB[7]*-2.9902437;
	dSum += fcCountsA[14]*fcCountsB[8]* 2.1087374;
	dSum += fcCountsA[14]*fcCountsB[9]*-2.1545730;
	dSum += fcCountsA[14]*fcCountsB[10]*-1.3671297;
	dSum += fcCountsA[14]*fcCountsB[11]*-0.4397837;
	dSum += fcCountsA[14]*fcCountsB[12]*-2.1085762;
	dSum += fcCountsA[14]*fcCountsB[13]* 0.9827740;
	dSum += fcCountsA[14]*fcCountsB[14]* 5.4734595;
	dSum += fcCountsA[14]*fcCountsB[15]*-0.7647782;
	dSum += fcCountsA[14]*fcCountsB[16]*-1.1223311;
	dSum += fcCountsA[14]*fcCountsB[17]*-2.5025824;
	dSum += fcCountsA[14]*fcCountsB[18]*-2.6793849;
	dSum += fcCountsA[14]*fcCountsB[19]*-1.6938669;
	dSum += fcCountsA[15]*fcCountsB[0]* 1.1157587;
	dSum += fcCountsA[15]*fcCountsB[1]*-0.8749933;
	dSum += fcCountsA[15]*fcCountsB[2]*-0.2610307;
	dSum += fcCountsA[15]*fcCountsB[3]*-0.1469171;
	dSum += fcCountsA[15]*fcCountsB[4]*-2.3690224;
	dSum += fcCountsA[15]*fcCountsB[5]*-0.2924989;
	dSum += fcCountsA[15]*fcCountsB[6]*-0.8815769;
	dSum += fcCountsA[15]*fcCountsB[7]*-2.3481785;
	dSum += fcCountsA[15]*fcCountsB[8]*-0.2034464;
	dSum += fcCountsA[15]*fcCountsB[9]*-2.4426147;
	dSum += fcCountsA[15]*fcCountsB[10]*-1.4808749;
	dSum += fcCountsA[15]*fcCountsB[11]* 0.6009010;
	dSum += fcCountsA[15]*fcCountsB[12]*-0.8089802;
	dSum += fcCountsA[15]*fcCountsB[13]*-0.1011365;
	dSum += fcCountsA[15]*fcCountsB[14]*-0.7647782;
	dSum += fcCountsA[15]*fcCountsB[15]* 3.8843515;
	dSum += fcCountsA[15]*fcCountsB[16]* 1.3811391;
	dSum += fcCountsA[15]*fcCountsB[17]*-1.6462106;
	dSum += fcCountsA[15]*fcCountsB[18]*-2.7518686;
	dSum += fcCountsA[15]*fcCountsB[19]*-1.6858057;
	dSum += fcCountsA[16]*fcCountsB[0]*-0.0453604;
	dSum += fcCountsA[16]*fcCountsB[1]*-0.8666503;
	dSum += fcCountsA[16]*fcCountsB[2]*-1.0507031;
	dSum += fcCountsA[16]*fcCountsB[3]*-0.8632508;
	dSum += fcCountsA[16]*fcCountsB[4]*-2.1076281;
	dSum += fcCountsA[16]*fcCountsB[5]*-1.5753783;
	dSum += fcCountsA[16]*fcCountsB[6]*-1.6859019;
	dSum += fcCountsA[16]*fcCountsB[7]*-0.7175874;
	dSum += fcCountsA[16]*fcCountsB[8]*-0.6695567;
	dSum += fcCountsA[16]*fcCountsB[9]*-1.1974854;
	dSum += fcCountsA[16]*fcCountsB[10]*-0.6662985;
	dSum += fcCountsA[16]*fcCountsB[11]*-0.0460924;
	dSum += fcCountsA[16]*fcCountsB[12]*-1.0752829;
	dSum += fcCountsA[16]*fcCountsB[13]*-0.6753267;
	dSum += fcCountsA[16]*fcCountsB[14]*-1.1223311;
	dSum += fcCountsA[16]*fcCountsB[15]* 1.3811391;
	dSum += fcCountsA[16]*fcCountsB[16]* 4.5453035;
	dSum += fcCountsA[16]*fcCountsB[17]*-0.0555170;
	dSum += fcCountsA[16]*fcCountsB[18]*-2.4289377;
	dSum += fcCountsA[16]*fcCountsB[19]*-1.6059919;
	dSum += fcCountsA[17]*fcCountsB[0]*-0.1894263;
	dSum += fcCountsA[17]*fcCountsB[1]*-0.8076761;
	dSum += fcCountsA[17]*fcCountsB[2]*-3.1426396;
	dSum += fcCountsA[17]*fcCountsB[3]*-2.4422836;
	dSum += fcCountsA[17]*fcCountsB[4]*-0.8490293;
	dSum += fcCountsA[17]*fcCountsB[5]*-3.1387434;
	dSum += fcCountsA[17]*fcCountsB[6]*-3.1174802;
	dSum += fcCountsA[17]*fcCountsB[7]* 2.5470463;
	dSum += fcCountsA[17]*fcCountsB[8]*-2.2623551;
	dSum += fcCountsA[17]*fcCountsB[9]* 0.7884477;
	dSum += fcCountsA[17]*fcCountsB[10]* 0.6872398;
	dSum += fcCountsA[17]*fcCountsB[11]*-2.8763484;
	dSum += fcCountsA[17]*fcCountsB[12]*-2.3487055;
	dSum += fcCountsA[17]*fcCountsB[13]*-2.1983822;
	dSum += fcCountsA[17]*fcCountsB[14]*-2.5025824;
	dSum += fcCountsA[17]*fcCountsB[15]*-1.6462106;
	dSum += fcCountsA[17]*fcCountsB[16]*-0.0555170;
	dSum += fcCountsA[17]*fcCountsB[17]* 3.7689264;
	dSum += fcCountsA[17]*fcCountsB[18]*-2.8342513;
	dSum += fcCountsA[17]*fcCountsB[19]*-1.2075102;
	dSum += fcCountsA[18]*fcCountsB[0]*-2.5268877;
	dSum += fcCountsA[18]*fcCountsB[1]*-2.3041298;
	dSum += fcCountsA[18]*fcCountsB[2]*-4.2143008;
	dSum += fcCountsA[18]*fcCountsB[3]*-2.8354498;
	dSum += fcCountsA[18]*fcCountsB[4]* 0.9175567;
	dSum += fcCountsA[18]*fcCountsB[5]*-2.4914919;
	dSum += fcCountsA[18]*fcCountsB[6]*-2.3421789;
	dSum += fcCountsA[18]*fcCountsB[7]*-2.5805492;
	dSum += fcCountsA[18]*fcCountsB[8]*-2.9564357;
	dSum += fcCountsA[18]*fcCountsB[9]*-1.6318918;
	dSum += fcCountsA[18]*fcCountsB[10]*-1.4248085;
	dSum += fcCountsA[18]*fcCountsB[11]*-3.6959279;
	dSum += fcCountsA[18]*fcCountsB[12]*-3.6541846;
	dSum += fcCountsA[18]*fcCountsB[13]*-1.9464942;
	dSum += fcCountsA[18]*fcCountsB[14]*-2.6793849;
	dSum += fcCountsA[18]*fcCountsB[15]*-2.7518686;
	dSum += fcCountsA[18]*fcCountsB[16]*-2.4289377;
	dSum += fcCountsA[18]*fcCountsB[17]*-2.8342513;
	dSum += fcCountsA[18]*fcCountsB[18]*10.5040275;
	dSum += fcCountsA[18]*fcCountsB[19]* 2.1542201;
	dSum += fcCountsA[19]*fcCountsB[0]*-1.7640114;
	dSum += fcCountsA[19]*fcCountsB[1]*-2.4071280;
	dSum += fcCountsA[19]*fcCountsB[2]*-3.0649574;
	dSum += fcCountsA[19]*fcCountsB[3]*-2.0204641;
	dSum += fcCountsA[19]*fcCountsB[4]* 2.9391278;
	dSum += fcCountsA[19]*fcCountsB[5]*-3.0397666;
	dSum += fcCountsA[19]*fcCountsB[6]* 1.6926313;
	dSum += fcCountsA[19]*fcCountsB[7]*-1.3313680;
	dSum += fcCountsA[19]*fcCountsB[8]*-1.8200362;
	dSum += fcCountsA[19]*fcCountsB[9]*-1.0620664;
	dSum += fcCountsA[19]*fcCountsB[10]*-0.9948761;
	dSum += fcCountsA[19]*fcCountsB[11]*-2.0817604;
	dSum += fcCountsA[19]*fcCountsB[12]*-2.9197736;
	dSum += fcCountsA[19]*fcCountsB[13]*-1.4210626;
	dSum += fcCountsA[19]*fcCountsB[14]*-1.6938669;
	dSum += fcCountsA[19]*fcCountsB[15]*-1.6858057;
	dSum += fcCountsA[19]*fcCountsB[16]*-1.6059919;
	dSum += fcCountsA[19]*fcCountsB[17]*-1.2075102;
	dSum += fcCountsA[19]*fcCountsB[18]* 2.1542201;
	dSum += fcCountsA[19]*fcCountsB[19]* 6.5950301;

	return (SCORE) dSum;
	}

SCORE PWALI::ALIScore(const FCOUNT fcCountsA[MAX_ALPHA],
  const FCOUNT fcCountsB[MAX_ALPHA])
	{
	double dSum = 0.0;
// Loop-unrolled double sum for average-log score computation (integer)
	dSum += fcCountsA[0]*fcCountsB[0]*         4;
	dSum += fcCountsA[0]*fcCountsB[1]*        -0;
	dSum += fcCountsA[0]*fcCountsB[2]*        -2;
	dSum += fcCountsA[0]*fcCountsB[3]*        -1;
	dSum += fcCountsA[0]*fcCountsB[4]*        -2;
	dSum += fcCountsA[0]*fcCountsB[5]*         0;
	dSum += fcCountsA[0]*fcCountsB[6]*        -2;
	dSum += fcCountsA[0]*fcCountsB[7]*        -1;
	dSum += fcCountsA[0]*fcCountsB[8]*        -1;
	dSum += fcCountsA[0]*fcCountsB[9]*        -1;
	dSum += fcCountsA[0]*fcCountsB[10]*        -1;
	dSum += fcCountsA[0]*fcCountsB[11]*        -2;
	dSum += fcCountsA[0]*fcCountsB[12]*        -1;
	dSum += fcCountsA[0]*fcCountsB[13]*        -1;
	dSum += fcCountsA[0]*fcCountsB[14]*        -1;
	dSum += fcCountsA[0]*fcCountsB[15]*         1;
	dSum += fcCountsA[0]*fcCountsB[16]*        -0;
	dSum += fcCountsA[0]*fcCountsB[17]*        -0;
	dSum += fcCountsA[0]*fcCountsB[18]*        -3;
	dSum += fcCountsA[0]*fcCountsB[19]*        -2;
	dSum += fcCountsA[1]*fcCountsB[0]*        -0;
	dSum += fcCountsA[1]*fcCountsB[1]*         9;
	dSum += fcCountsA[1]*fcCountsB[2]*        -3;
	dSum += fcCountsA[1]*fcCountsB[3]*        -4;
	dSum += fcCountsA[1]*fcCountsB[4]*        -2;
	dSum += fcCountsA[1]*fcCountsB[5]*        -3;
	dSum += fcCountsA[1]*fcCountsB[6]*        -3;
	dSum += fcCountsA[1]*fcCountsB[7]*        -1;
	dSum += fcCountsA[1]*fcCountsB[8]*        -3;
	dSum += fcCountsA[1]*fcCountsB[9]*        -1;
	dSum += fcCountsA[1]*fcCountsB[10]*        -1;
	dSum += fcCountsA[1]*fcCountsB[11]*        -3;
	dSum += fcCountsA[1]*fcCountsB[12]*        -3;
	dSum += fcCountsA[1]*fcCountsB[13]*        -3;
	dSum += fcCountsA[1]*fcCountsB[14]*        -3;
	dSum += fcCountsA[1]*fcCountsB[15]*        -1;
	dSum += fcCountsA[1]*fcCountsB[16]*        -1;
	dSum += fcCountsA[1]*fcCountsB[17]*        -1;
	dSum += fcCountsA[1]*fcCountsB[18]*        -2;
	dSum += fcCountsA[1]*fcCountsB[19]*        -2;
	dSum += fcCountsA[2]*fcCountsB[0]*        -2;
	dSum += fcCountsA[2]*fcCountsB[1]*        -3;
	dSum += fcCountsA[2]*fcCountsB[2]*         6;
	dSum += fcCountsA[2]*fcCountsB[3]*         2;
	dSum += fcCountsA[2]*fcCountsB[4]*        -3;
	dSum += fcCountsA[2]*fcCountsB[5]*        -1;
	dSum += fcCountsA[2]*fcCountsB[6]*        -1;
	dSum += fcCountsA[2]*fcCountsB[7]*        -3;
	dSum += fcCountsA[2]*fcCountsB[8]*        -1;
	dSum += fcCountsA[2]*fcCountsB[9]*        -4;
	dSum += fcCountsA[2]*fcCountsB[10]*        -3;
	dSum += fcCountsA[2]*fcCountsB[11]*         1;
	dSum += fcCountsA[2]*fcCountsB[12]*        -1;
	dSum += fcCountsA[2]*fcCountsB[13]*        -0;
	dSum += fcCountsA[2]*fcCountsB[14]*        -2;
	dSum += fcCountsA[2]*fcCountsB[15]*        -0;
	dSum += fcCountsA[2]*fcCountsB[16]*        -1;
	dSum += fcCountsA[2]*fcCountsB[17]*        -3;
	dSum += fcCountsA[2]*fcCountsB[18]*        -4;
	dSum += fcCountsA[2]*fcCountsB[19]*        -3;
	dSum += fcCountsA[3]*fcCountsB[0]*        -1;
	dSum += fcCountsA[3]*fcCountsB[1]*        -4;
	dSum += fcCountsA[3]*fcCountsB[2]*         2;
	dSum += fcCountsA[3]*fcCountsB[3]*         5;
	dSum += fcCountsA[3]*fcCountsB[4]*        -3;
	dSum += fcCountsA[3]*fcCountsB[5]*        -2;
	dSum += fcCountsA[3]*fcCountsB[6]*        -0;
	dSum += fcCountsA[3]*fcCountsB[7]*        -3;
	dSum += fcCountsA[3]*fcCountsB[8]*         1;
	dSum += fcCountsA[3]*fcCountsB[9]*        -3;
	dSum += fcCountsA[3]*fcCountsB[10]*        -2;
	dSum += fcCountsA[3]*fcCountsB[11]*        -0;
	dSum += fcCountsA[3]*fcCountsB[12]*        -1;
	dSum += fcCountsA[3]*fcCountsB[13]*         2;
	dSum += fcCountsA[3]*fcCountsB[14]*        -0;
	dSum += fcCountsA[3]*fcCountsB[15]*        -0;
	dSum += fcCountsA[3]*fcCountsB[16]*        -1;
	dSum += fcCountsA[3]*fcCountsB[17]*        -2;
	dSum += fcCountsA[3]*fcCountsB[18]*        -3;
	dSum += fcCountsA[3]*fcCountsB[19]*        -2;
	dSum += fcCountsA[4]*fcCountsB[0]*        -2;
	dSum += fcCountsA[4]*fcCountsB[1]*        -2;
	dSum += fcCountsA[4]*fcCountsB[2]*        -3;
	dSum += fcCountsA[4]*fcCountsB[3]*        -3;
	dSum += fcCountsA[4]*fcCountsB[4]*         6;
	dSum += fcCountsA[4]*fcCountsB[5]*        -3;
	dSum += fcCountsA[4]*fcCountsB[6]*        -1;
	dSum += fcCountsA[4]*fcCountsB[7]*        -0;
	dSum += fcCountsA[4]*fcCountsB[8]*        -3;
	dSum += fcCountsA[4]*fcCountsB[9]*         0;
	dSum += fcCountsA[4]*fcCountsB[10]*         0;
	dSum += fcCountsA[4]*fcCountsB[11]*        -3;
	dSum += fcCountsA[4]*fcCountsB[12]*        -4;
	dSum += fcCountsA[4]*fcCountsB[13]*        -3;
	dSum += fcCountsA[4]*fcCountsB[14]*        -3;
	dSum += fcCountsA[4]*fcCountsB[15]*        -2;
	dSum += fcCountsA[4]*fcCountsB[16]*        -2;
	dSum += fcCountsA[4]*fcCountsB[17]*        -1;
	dSum += fcCountsA[4]*fcCountsB[18]*         1;
	dSum += fcCountsA[4]*fcCountsB[19]*         3;
	dSum += fcCountsA[5]*fcCountsB[0]*         0;
	dSum += fcCountsA[5]*fcCountsB[1]*        -3;
	dSum += fcCountsA[5]*fcCountsB[2]*        -1;
	dSum += fcCountsA[5]*fcCountsB[3]*        -2;
	dSum += fcCountsA[5]*fcCountsB[4]*        -3;
	dSum += fcCountsA[5]*fcCountsB[5]*         6;
	dSum += fcCountsA[5]*fcCountsB[6]*        -2;
	dSum += fcCountsA[5]*fcCountsB[7]*        -4;
	dSum += fcCountsA[5]*fcCountsB[8]*        -2;
	dSum += fcCountsA[5]*fcCountsB[9]*        -4;
	dSum += fcCountsA[5]*fcCountsB[10]*        -3;
	dSum += fcCountsA[5]*fcCountsB[11]*        -0;
	dSum += fcCountsA[5]*fcCountsB[12]*        -2;
	dSum += fcCountsA[5]*fcCountsB[13]*        -2;
	dSum += fcCountsA[5]*fcCountsB[14]*        -2;
	dSum += fcCountsA[5]*fcCountsB[15]*        -0;
	dSum += fcCountsA[5]*fcCountsB[16]*        -2;
	dSum += fcCountsA[5]*fcCountsB[17]*        -3;
	dSum += fcCountsA[5]*fcCountsB[18]*        -2;
	dSum += fcCountsA[5]*fcCountsB[19]*        -3;
	dSum += fcCountsA[6]*fcCountsB[0]*        -2;
	dSum += fcCountsA[6]*fcCountsB[1]*        -3;
	dSum += fcCountsA[6]*fcCountsB[2]*        -1;
	dSum += fcCountsA[6]*fcCountsB[3]*        -0;
	dSum += fcCountsA[6]*fcCountsB[4]*        -1;
	dSum += fcCountsA[6]*fcCountsB[5]*        -2;
	dSum += fcCountsA[6]*fcCountsB[6]*         8;
	dSum += fcCountsA[6]*fcCountsB[7]*        -3;
	dSum += fcCountsA[6]*fcCountsB[8]*        -1;
	dSum += fcCountsA[6]*fcCountsB[9]*        -3;
	dSum += fcCountsA[6]*fcCountsB[10]*        -2;
	dSum += fcCountsA[6]*fcCountsB[11]*         1;
	dSum += fcCountsA[6]*fcCountsB[12]*        -2;
	dSum += fcCountsA[6]*fcCountsB[13]*         0;
	dSum += fcCountsA[6]*fcCountsB[14]*        -0;
	dSum += fcCountsA[6]*fcCountsB[15]*        -1;
	dSum += fcCountsA[6]*fcCountsB[16]*        -2;
	dSum += fcCountsA[6]*fcCountsB[17]*        -3;
	dSum += fcCountsA[6]*fcCountsB[18]*        -2;
	dSum += fcCountsA[6]*fcCountsB[19]*         2;
	dSum += fcCountsA[7]*fcCountsB[0]*        -1;
	dSum += fcCountsA[7]*fcCountsB[1]*        -1;
	dSum += fcCountsA[7]*fcCountsB[2]*        -3;
	dSum += fcCountsA[7]*fcCountsB[3]*        -3;
	dSum += fcCountsA[7]*fcCountsB[4]*        -0;
	dSum += fcCountsA[7]*fcCountsB[5]*        -4;
	dSum += fcCountsA[7]*fcCountsB[6]*        -3;
	dSum += fcCountsA[7]*fcCountsB[7]*         4;
	dSum += fcCountsA[7]*fcCountsB[8]*        -3;
	dSum += fcCountsA[7]*fcCountsB[9]*         2;
	dSum += fcCountsA[7]*fcCountsB[10]*         1;
	dSum += fcCountsA[7]*fcCountsB[11]*        -3;
	dSum += fcCountsA[7]*fcCountsB[12]*        -3;
	dSum += fcCountsA[7]*fcCountsB[13]*        -3;
	dSum += fcCountsA[7]*fcCountsB[14]*        -3;
	dSum += fcCountsA[7]*fcCountsB[15]*        -2;
	dSum += fcCountsA[7]*fcCountsB[16]*        -1;
	dSum += fcCountsA[7]*fcCountsB[17]*         3;
	dSum += fcCountsA[7]*fcCountsB[18]*        -3;
	dSum += fcCountsA[7]*fcCountsB[19]*        -1;
	dSum += fcCountsA[8]*fcCountsB[0]*        -1;
	dSum += fcCountsA[8]*fcCountsB[1]*        -3;
	dSum += fcCountsA[8]*fcCountsB[2]*        -1;
	dSum += fcCountsA[8]*fcCountsB[3]*         1;
	dSum += fcCountsA[8]*fcCountsB[4]*        -3;
	dSum += fcCountsA[8]*fcCountsB[5]*        -2;
	dSum += fcCountsA[8]*fcCountsB[6]*        -1;
	dSum += fcCountsA[8]*fcCountsB[7]*        -3;
	dSum += fcCountsA[8]*fcCountsB[8]*         5;
	dSum += fcCountsA[8]*fcCountsB[9]*        -2;
	dSum += fcCountsA[8]*fcCountsB[10]*        -1;
	dSum += fcCountsA[8]*fcCountsB[11]*        -0;
	dSum += fcCountsA[8]*fcCountsB[12]*        -1;
	dSum += fcCountsA[8]*fcCountsB[13]*         1;
	dSum += fcCountsA[8]*fcCountsB[14]*         2;
	dSum += fcCountsA[8]*fcCountsB[15]*        -0;
	dSum += fcCountsA[8]*fcCountsB[16]*        -1;
	dSum += fcCountsA[8]*fcCountsB[17]*        -2;
	dSum += fcCountsA[8]*fcCountsB[18]*        -3;
	dSum += fcCountsA[8]*fcCountsB[19]*        -2;
	dSum += fcCountsA[9]*fcCountsB[0]*        -1;
	dSum += fcCountsA[9]*fcCountsB[1]*        -1;
	dSum += fcCountsA[9]*fcCountsB[2]*        -4;
	dSum += fcCountsA[9]*fcCountsB[3]*        -3;
	dSum += fcCountsA[9]*fcCountsB[4]*         0;
	dSum += fcCountsA[9]*fcCountsB[5]*        -4;
	dSum += fcCountsA[9]*fcCountsB[6]*        -3;
	dSum += fcCountsA[9]*fcCountsB[7]*         2;
	dSum += fcCountsA[9]*fcCountsB[8]*        -2;
	dSum += fcCountsA[9]*fcCountsB[9]*         4;
	dSum += fcCountsA[9]*fcCountsB[10]*         2;
	dSum += fcCountsA[9]*fcCountsB[11]*        -3;
	dSum += fcCountsA[9]*fcCountsB[12]*        -3;
	dSum += fcCountsA[9]*fcCountsB[13]*        -2;
	dSum += fcCountsA[9]*fcCountsB[14]*        -2;
	dSum += fcCountsA[9]*fcCountsB[15]*        -2;
	dSum += fcCountsA[9]*fcCountsB[16]*        -1;
	dSum += fcCountsA[9]*fcCountsB[17]*         1;
	dSum += fcCountsA[9]*fcCountsB[18]*        -2;
	dSum += fcCountsA[9]*fcCountsB[19]*        -1;
	dSum += fcCountsA[10]*fcCountsB[0]*        -1;
	dSum += fcCountsA[10]*fcCountsB[1]*        -1;
	dSum += fcCountsA[10]*fcCountsB[2]*        -3;
	dSum += fcCountsA[10]*fcCountsB[3]*        -2;
	dSum += fcCountsA[10]*fcCountsB[4]*         0;
	dSum += fcCountsA[10]*fcCountsB[5]*        -3;
	dSum += fcCountsA[10]*fcCountsB[6]*        -2;
	dSum += fcCountsA[10]*fcCountsB[7]*         1;
	dSum += fcCountsA[10]*fcCountsB[8]*        -1;
	dSum += fcCountsA[10]*fcCountsB[9]*         2;
	dSum += fcCountsA[10]*fcCountsB[10]*         5;
	dSum += fcCountsA[10]*fcCountsB[11]*        -2;
	dSum += fcCountsA[10]*fcCountsB[12]*        -2;
	dSum += fcCountsA[10]*fcCountsB[13]*        -0;
	dSum += fcCountsA[10]*fcCountsB[14]*        -1;
	dSum += fcCountsA[10]*fcCountsB[15]*        -1;
	dSum += fcCountsA[10]*fcCountsB[16]*        -1;
	dSum += fcCountsA[10]*fcCountsB[17]*         1;
	dSum += fcCountsA[10]*fcCountsB[18]*        -1;
	dSum += fcCountsA[10]*fcCountsB[19]*        -1;
	dSum += fcCountsA[11]*fcCountsB[0]*        -2;
	dSum += fcCountsA[11]*fcCountsB[1]*        -3;
	dSum += fcCountsA[11]*fcCountsB[2]*         1;
	dSum += fcCountsA[11]*fcCountsB[3]*        -0;
	dSum += fcCountsA[11]*fcCountsB[4]*        -3;
	dSum += fcCountsA[11]*fcCountsB[5]*        -0;
	dSum += fcCountsA[11]*fcCountsB[6]*         1;
	dSum += fcCountsA[11]*fcCountsB[7]*        -3;
	dSum += fcCountsA[11]*fcCountsB[8]*        -0;
	dSum += fcCountsA[11]*fcCountsB[9]*        -3;
	dSum += fcCountsA[11]*fcCountsB[10]*        -2;
	dSum += fcCountsA[11]*fcCountsB[11]*         6;
	dSum += fcCountsA[11]*fcCountsB[12]*        -2;
	dSum += fcCountsA[11]*fcCountsB[13]*         0;
	dSum += fcCountsA[11]*fcCountsB[14]*        -0;
	dSum += fcCountsA[11]*fcCountsB[15]*         1;
	dSum += fcCountsA[11]*fcCountsB[16]*        -0;
	dSum += fcCountsA[11]*fcCountsB[17]*        -3;
	dSum += fcCountsA[11]*fcCountsB[18]*        -4;
	dSum += fcCountsA[11]*fcCountsB[19]*        -2;
	dSum += fcCountsA[12]*fcCountsB[0]*        -1;
	dSum += fcCountsA[12]*fcCountsB[1]*        -3;
	dSum += fcCountsA[12]*fcCountsB[2]*        -1;
	dSum += fcCountsA[12]*fcCountsB[3]*        -1;
	dSum += fcCountsA[12]*fcCountsB[4]*        -4;
	dSum += fcCountsA[12]*fcCountsB[5]*        -2;
	dSum += fcCountsA[12]*fcCountsB[6]*        -2;
	dSum += fcCountsA[12]*fcCountsB[7]*        -3;
	dSum += fcCountsA[12]*fcCountsB[8]*        -1;
	dSum += fcCountsA[12]*fcCountsB[9]*        -3;
	dSum += fcCountsA[12]*fcCountsB[10]*        -2;
	dSum += fcCountsA[12]*fcCountsB[11]*        -2;
	dSum += fcCountsA[12]*fcCountsB[12]*         7;
	dSum += fcCountsA[12]*fcCountsB[13]*        -1;
	dSum += fcCountsA[12]*fcCountsB[14]*        -2;
	dSum += fcCountsA[12]*fcCountsB[15]*        -1;
	dSum += fcCountsA[12]*fcCountsB[16]*        -1;
	dSum += fcCountsA[12]*fcCountsB[17]*        -2;
	dSum += fcCountsA[12]*fcCountsB[18]*        -4;
	dSum += fcCountsA[12]*fcCountsB[19]*        -3;
	dSum += fcCountsA[13]*fcCountsB[0]*        -1;
	dSum += fcCountsA[13]*fcCountsB[1]*        -3;
	dSum += fcCountsA[13]*fcCountsB[2]*        -0;
	dSum += fcCountsA[13]*fcCountsB[3]*         2;
	dSum += fcCountsA[13]*fcCountsB[4]*        -3;
	dSum += fcCountsA[13]*fcCountsB[5]*        -2;
	dSum += fcCountsA[13]*fcCountsB[6]*         0;
	dSum += fcCountsA[13]*fcCountsB[7]*        -3;
	dSum += fcCountsA[13]*fcCountsB[8]*         1;
	dSum += fcCountsA[13]*fcCountsB[9]*        -2;
	dSum += fcCountsA[13]*fcCountsB[10]*        -0;
	dSum += fcCountsA[13]*fcCountsB[11]*         0;
	dSum += fcCountsA[13]*fcCountsB[12]*        -1;
	dSum += fcCountsA[13]*fcCountsB[13]*         5;
	dSum += fcCountsA[13]*fcCountsB[14]*         1;
	dSum += fcCountsA[13]*fcCountsB[15]*        -0;
	dSum += fcCountsA[13]*fcCountsB[16]*        -1;
	dSum += fcCountsA[13]*fcCountsB[17]*        -2;
	dSum += fcCountsA[13]*fcCountsB[18]*        -2;
	dSum += fcCountsA[13]*fcCountsB[19]*        -1;
	dSum += fcCountsA[14]*fcCountsB[0]*        -1;
	dSum += fcCountsA[14]*fcCountsB[1]*        -3;
	dSum += fcCountsA[14]*fcCountsB[2]*        -2;
	dSum += fcCountsA[14]*fcCountsB[3]*        -0;
	dSum += fcCountsA[14]*fcCountsB[4]*        -3;
	dSum += fcCountsA[14]*fcCountsB[5]*        -2;
	dSum += fcCountsA[14]*fcCountsB[6]*        -0;
	dSum += fcCountsA[14]*fcCountsB[7]*        -3;
	dSum += fcCountsA[14]*fcCountsB[8]*         2;
	dSum += fcCountsA[14]*fcCountsB[9]*        -2;
	dSum += fcCountsA[14]*fcCountsB[10]*        -1;
	dSum += fcCountsA[14]*fcCountsB[11]*        -0;
	dSum += fcCountsA[14]*fcCountsB[12]*        -2;
	dSum += fcCountsA[14]*fcCountsB[13]*         1;
	dSum += fcCountsA[14]*fcCountsB[14]*         5;
	dSum += fcCountsA[14]*fcCountsB[15]*        -1;
	dSum += fcCountsA[14]*fcCountsB[16]*        -1;
	dSum += fcCountsA[14]*fcCountsB[17]*        -3;
	dSum += fcCountsA[14]*fcCountsB[18]*        -3;
	dSum += fcCountsA[14]*fcCountsB[19]*        -2;
	dSum += fcCountsA[15]*fcCountsB[0]*         1;
	dSum += fcCountsA[15]*fcCountsB[1]*        -1;
	dSum += fcCountsA[15]*fcCountsB[2]*        -0;
	dSum += fcCountsA[15]*fcCountsB[3]*        -0;
	dSum += fcCountsA[15]*fcCountsB[4]*        -2;
	dSum += fcCountsA[15]*fcCountsB[5]*        -0;
	dSum += fcCountsA[15]*fcCountsB[6]*        -1;
	dSum += fcCountsA[15]*fcCountsB[7]*        -2;
	dSum += fcCountsA[15]*fcCountsB[8]*        -0;
	dSum += fcCountsA[15]*fcCountsB[9]*        -2;
	dSum += fcCountsA[15]*fcCountsB[10]*        -1;
	dSum += fcCountsA[15]*fcCountsB[11]*         1;
	dSum += fcCountsA[15]*fcCountsB[12]*        -1;
	dSum += fcCountsA[15]*fcCountsB[13]*        -0;
	dSum += fcCountsA[15]*fcCountsB[14]*        -1;
	dSum += fcCountsA[15]*fcCountsB[15]*         4;
	dSum += fcCountsA[15]*fcCountsB[16]*         1;
	dSum += fcCountsA[15]*fcCountsB[17]*        -2;
	dSum += fcCountsA[15]*fcCountsB[18]*        -3;
	dSum += fcCountsA[15]*fcCountsB[19]*        -2;
	dSum += fcCountsA[16]*fcCountsB[0]*        -0;
	dSum += fcCountsA[16]*fcCountsB[1]*        -1;
	dSum += fcCountsA[16]*fcCountsB[2]*        -1;
	dSum += fcCountsA[16]*fcCountsB[3]*        -1;
	dSum += fcCountsA[16]*fcCountsB[4]*        -2;
	dSum += fcCountsA[16]*fcCountsB[5]*        -2;
	dSum += fcCountsA[16]*fcCountsB[6]*        -2;
	dSum += fcCountsA[16]*fcCountsB[7]*        -1;
	dSum += fcCountsA[16]*fcCountsB[8]*        -1;
	dSum += fcCountsA[16]*fcCountsB[9]*        -1;
	dSum += fcCountsA[16]*fcCountsB[10]*        -1;
	dSum += fcCountsA[16]*fcCountsB[11]*        -0;
	dSum += fcCountsA[16]*fcCountsB[12]*        -1;
	dSum += fcCountsA[16]*fcCountsB[13]*        -1;
	dSum += fcCountsA[16]*fcCountsB[14]*        -1;
	dSum += fcCountsA[16]*fcCountsB[15]*         1;
	dSum += fcCountsA[16]*fcCountsB[16]*         5;
	dSum += fcCountsA[16]*fcCountsB[17]*        -0;
	dSum += fcCountsA[16]*fcCountsB[18]*        -2;
	dSum += fcCountsA[16]*fcCountsB[19]*        -2;
	dSum += fcCountsA[17]*fcCountsB[0]*        -0;
	dSum += fcCountsA[17]*fcCountsB[1]*        -1;
	dSum += fcCountsA[17]*fcCountsB[2]*        -3;
	dSum += fcCountsA[17]*fcCountsB[3]*        -2;
	dSum += fcCountsA[17]*fcCountsB[4]*        -1;
	dSum += fcCountsA[17]*fcCountsB[5]*        -3;
	dSum += fcCountsA[17]*fcCountsB[6]*        -3;
	dSum += fcCountsA[17]*fcCountsB[7]*         3;
	dSum += fcCountsA[17]*fcCountsB[8]*        -2;
	dSum += fcCountsA[17]*fcCountsB[9]*         1;
	dSum += fcCountsA[17]*fcCountsB[10]*         1;
	dSum += fcCountsA[17]*fcCountsB[11]*        -3;
	dSum += fcCountsA[17]*fcCountsB[12]*        -2;
	dSum += fcCountsA[17]*fcCountsB[13]*        -2;
	dSum += fcCountsA[17]*fcCountsB[14]*        -3;
	dSum += fcCountsA[17]*fcCountsB[15]*        -2;
	dSum += fcCountsA[17]*fcCountsB[16]*        -0;
	dSum += fcCountsA[17]*fcCountsB[17]*         4;
	dSum += fcCountsA[17]*fcCountsB[18]*        -3;
	dSum += fcCountsA[17]*fcCountsB[19]*        -1;
	dSum += fcCountsA[18]*fcCountsB[0]*        -3;
	dSum += fcCountsA[18]*fcCountsB[1]*        -2;
	dSum += fcCountsA[18]*fcCountsB[2]*        -4;
	dSum += fcCountsA[18]*fcCountsB[3]*        -3;
	dSum += fcCountsA[18]*fcCountsB[4]*         1;
	dSum += fcCountsA[18]*fcCountsB[5]*        -2;
	dSum += fcCountsA[18]*fcCountsB[6]*        -2;
	dSum += fcCountsA[18]*fcCountsB[7]*        -3;
	dSum += fcCountsA[18]*fcCountsB[8]*        -3;
	dSum += fcCountsA[18]*fcCountsB[9]*        -2;
	dSum += fcCountsA[18]*fcCountsB[10]*        -1;
	dSum += fcCountsA[18]*fcCountsB[11]*        -4;
	dSum += fcCountsA[18]*fcCountsB[12]*        -4;
	dSum += fcCountsA[18]*fcCountsB[13]*        -2;
	dSum += fcCountsA[18]*fcCountsB[14]*        -3;
	dSum += fcCountsA[18]*fcCountsB[15]*        -3;
	dSum += fcCountsA[18]*fcCountsB[16]*        -2;
	dSum += fcCountsA[18]*fcCountsB[17]*        -3;
	dSum += fcCountsA[18]*fcCountsB[18]*        11;
	dSum += fcCountsA[18]*fcCountsB[19]*         2;
	dSum += fcCountsA[19]*fcCountsB[0]*        -2;
	dSum += fcCountsA[19]*fcCountsB[1]*        -2;
	dSum += fcCountsA[19]*fcCountsB[2]*        -3;
	dSum += fcCountsA[19]*fcCountsB[3]*        -2;
	dSum += fcCountsA[19]*fcCountsB[4]*         3;
	dSum += fcCountsA[19]*fcCountsB[5]*        -3;
	dSum += fcCountsA[19]*fcCountsB[6]*         2;
	dSum += fcCountsA[19]*fcCountsB[7]*        -1;
	dSum += fcCountsA[19]*fcCountsB[8]*        -2;
	dSum += fcCountsA[19]*fcCountsB[9]*        -1;
	dSum += fcCountsA[19]*fcCountsB[10]*        -1;
	dSum += fcCountsA[19]*fcCountsB[11]*        -2;
	dSum += fcCountsA[19]*fcCountsB[12]*        -3;
	dSum += fcCountsA[19]*fcCountsB[13]*        -1;
	dSum += fcCountsA[19]*fcCountsB[14]*        -2;
	dSum += fcCountsA[19]*fcCountsB[15]*        -2;
	dSum += fcCountsA[19]*fcCountsB[16]*        -2;
	dSum += fcCountsA[19]*fcCountsB[17]*        -1;
	dSum += fcCountsA[19]*fcCountsB[18]*         2;
	dSum += fcCountsA[19]*fcCountsB[19]*         7;

	return (SCORE) dSum;
	}
