// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "Profile.h"
#include "MSA.h"
#include "TextFile.h"
#include "DataBuffer.h"

void DoBuildProf(const char *in, const char *prof)
	{
	TextFile InFile(in);
	MSA a;
	a.FromFile(InFile);
	a.AlignByCase();
	a.BuildPillars();

	const char *seed = GetOptionalParam("seed");
	if (0 == seed)
		seed = a.GetSeqName(0);

	Profile Prof;
	Prof.FromMSA(a, seed);

	DataBuffer Data;
	Prof.ToBuffer(Data);

	Data.ToFile(prof);
	}
