// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "MSA.h"
#include "TextFile.h"

void DoConsensus(const char *in1, const char *in2, const char *out)
	{
	TextFile FileA(in1);
	TextFile FileB(in2);

	MSA msaA;
	MSA msaB;

	msaA.FromFASTAFile(FileA);
	msaB.FromFASTAFile(FileB);

	msaA.AlignByCase();
	msaB.AlignByCase();

	MSA msaOut;
	Consensus(msaA, msaB, msaOut);

	TextFile FileOut(out, true);
	msaOut.ToFASTAFile(FileOut);
	}
