// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "SAMMod.h"
#include "HMM.h"
#include "TextFile.h"

void DoHMM2SAM(const char *in, const char *sam)
	{
	TextFile InFile(in);
	HMM Model;
	Model.FromFile(InFile);
	
	SAMMod Mod;
	Mod.FromHMM(Model);

	TextFile OutFile(sam, true);
	Mod.ToFile(OutFile);
	}
