// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "Phylip.h"
#include "PhylipNode.h"
#include "TextFile.h"

void DoRootByOutlier(const char *strUnrootedFileName, const char *strRootedFileName)
	{
	TextFile InFile(strUnrootedFileName);
	Phylip Tree;
	Tree.FromFile(InFile);

	//List("Input tree:\n");
	//Tree.ListMe();

	PhylipNode *ptrOutlier = Tree.GetOutlier();
	if (0 == ptrOutlier)
		Quit("No outlier found");

	//List("Outlier %s\n", ptrOutlier->GetName());

	//Tree.ListFromEdge(ptrOutlier, ptrOutlier->GetUnrootedParent());
	//Tree.ListFromEdge(ptrOutlier->GetUnrootedParent(), ptrOutlier);

	Phylip *ptrNewTree = Tree.Root(ptrOutlier);

	//List("Rooted tree:\n");
	//ptrNewTree->ListMe();

	TextFile OutFile(strRootedFileName, true);
	ptrNewTree->ToFile(OutFile);
	}
