// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "DataBuffer.h"
#include "Profile.h"
#include "PWBase.h"

void DoScoreMasterProf(const char *in, const char *colpair)
	{
	DataBuffer Data;
	Data.FromFile(in);

	Profile profMaster;
	profMaster.FromBuffer(Data);

	PWBase *ptrPWS;
	PWSFactory(colpair, "simple", "LL", &ptrPWS);

	const unsigned uPairCount = profMaster.GetPosCount()/2;
	for (unsigned uPairIndex = 0; uPairIndex < uPairCount; ++uPairIndex)
		{
		const ProfPos &PPA = profMaster.GetPos(uPairIndex*2);
		const ProfPos &PPB = profMaster.GetPos(uPairIndex*2 + 1);

		double dScore = ptrPWS->ScoreProfPos(PPA, PPB);
		List("%.5g\n", dScore);
		}
	}
