// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "TextFile.h"
#include "MSA.h"

void DoShowTotalWeight(const char *strFileName)
	{
	TextFile File(strFileName);
	MSA a;
	a.FromFile(File);

	const unsigned uSeqCount = a.GetSeqCount();
	WCOUNT wcNIC = a.GetRawNIC();
	double dTotalWeight = WCountToDouble(wcNIC);
	printf("%s, total weight=%g\n", strFileName, dTotalWeight);
	List("%s, total weight=%g\n", strFileName, dTotalWeight);
	}
