// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "Phylip.h"
#include "PhylipNode.h"
#include "TextFile.h"
#include "MSA.h"
#include "Clust.h"
#include "ClustSetMSA.h"
#include "MSADistKimura.h"

void DoUPGMA(const char *in, const char *out)
	{
	TextFile fileIn(in);
	
	MSA msa;
	msa.FromFASTAFile(fileIn);
	msa.AlignByCase();

	MSADistKimura MD;
	ClustSetMSA Set(msa, JOINSTYLE_NearestNeighbor, CENTROIDSTYLE_AverageLinkage,
	  true, MD);

	Clust C;
	C.Create(Set);
	C.ListMe();

	Phylip Tree;
	C.ToPhylip(Tree);

	TextFile fileOut(out, true);
	Tree.ToFile(fileOut);
	}
