// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

class HMMPath;

const unsigned MAX_HMM_PATH = 4096;

class HMMPath;
class PWPath;

class EnumPathsSink
	{
protected:
	EnumPathsSink() {}
	virtual ~EnumPathsSink() {}

public:
	virtual void OnPath(const HMMPath &Path) = 0;
	};

class EnumPWPathsSink
	{
protected:
	EnumPWPathsSink() {}
	virtual ~EnumPWPathsSink() {}

public:
	virtual void OnPath(const PWPath &Path) = 0;
	};

bool NextChain(unsigned j, unsigned N, unsigned Links[], bool &bFirst);

void EnumPaths(unsigned uNodeCount, unsigned uSeqLength, MODEL_BOUNDS ModelBounds,
  SEQ_BOUNDS SeqBounds, EnumPathsSink &Sink);

void EnumPWPaths(unsigned uLengthA, unsigned uLengthB, BOUNDS BoundsA, 
  BOUNDS BoundsB, EnumPWPathsSink &Sink);
