// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#ifndef	PWDir_h
#define	PWDir_h

#include "PWBase.h"

class PWDir : public PWBase
	{
public:
	PWDir()
		{
		}

	virtual ~PWDir()
		{
		}

	virtual PWCLASS GetClass() const { return PWCLASS_Dir; }

// Score is (Freq vector) dot (Freq vector)
	virtual SCORE ScoreProfPos(const ProfPos &PPA, const ProfPos &PPB) const
		{
		double dCounts[MAX_ALPHA];

		for (unsigned uLetter = 0; uLetter < MAX_ALPHA; ++uLetter)
//			dCounts[uLetter] = PPA.m_fcCounts[uLetter]*GetNICA() + PPB.m_fcCounts[uLetter]*GetNICB();
			dCounts[uLetter] = PPA.m_fcCounts[uLetter]*3 + PPB.m_fcCounts[uLetter]*3;

		return PWDirScoreN(dCounts);
		}

	static SCORE PWDirScore(const FCOUNT fcCountsA[], const FCOUNT fcCountsB[]);
	static SCORE PWDirScoreN(const double dCounts[]);
	};

#endif	// PWDir_h
