// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#ifndef	PWEuclidF_h
#define	PWEuclidF_h

#include "PWBase.h"

class PWEuclidF : public PWBase
	{
public:
	PWEuclidF()
		{
		}

	virtual ~PWEuclidF()
		{
		}

	virtual PWCLASS GetClass() const { return PWCLASS_EuclidF; }

	virtual SCORE ScoreProfPos(const ProfPos &PPA, const ProfPos &PPB) const
		{
		double dSum = 0;
		for (unsigned uLetter = 0; uLetter < MAX_ALPHA; ++uLetter)
			{
			double dDiff = PPA.m_fcCounts[uLetter] - PPB.m_fcCounts[uLetter];
			dSum += dDiff*dDiff;
			}
		return (SCORE) -sqrt(dSum);
		}
	};

#endif	// PWEuclidF_h
