// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#ifndef	PWLAM_h
#define	PWLAM_h

#include "PWBase.h"

class PWLAM : public PWBase
	{
public:
	PWLAM()
		{
		}

	virtual ~PWLAM()
		{
		}

	virtual SCORE DefaultGapOpen() const
		{
		return (SCORE) -3.5;
		}

	virtual SCORE DefaultGapExtend() const
		{
		return (SCORE) -0.4;
		}

	virtual SCORE ScoreProfPos(const ProfPos &PPA, const ProfPos &PPB) const
		{
		return LAMScore(PPA.m_fcCounts, PPB.m_fcCounts);
		}

	static SCORE PWLAM::LAMScore(const FCOUNT fcCountsA[MAX_ALPHA],
	  const FCOUNT fcCountsB[MAX_ALPHA]);
	};

#endif	// PWLAM_h
