// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#ifndef	PWLAP_h
#define	PWLAP_h

#include "PWBase.h"

class PWLAP : public PWBase
	{
public:
	PWLAP()
		{
		}

	virtual ~PWLAP()
		{
		}

	virtual SCORE DefaultGapOpen() const
		{
		return (SCORE) -3.587;
//		return (SCORE) -1.25;
		}

	virtual SCORE DefaultGapExtend() const
		{
		return (SCORE) -0.055;
//		return (SCORE) -0.01;
		}

	virtual SCORE ScoreProfPos(const ProfPos &PPA, const ProfPos &PPB) const
		{
		return LAPScore(PPA.m_Probs, PPB.m_Probs);
		}

	static SCORE PWLAP::LAPScore(const PROB probA[MAX_ALPHA],
	  const PROB probB[MAX_ALPHA]);
	};

#endif	// PWLAP_h
