// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#ifndef	PWMDotM_h
#define	PWMDotM_h

#include "PWBase.h"

class PWMDotM : public PWBase
	{
public:
	PWMDotM()
		{
		}

	virtual ~PWMDotM()
		{
		}

	virtual PWCLASS GetClass() const { return PWCLASS_MdotM; }

	virtual SCORE ScoreProfPos(const ProfPos &PPA, const ProfPos &PPB) const
		{
		SCORE Score = 0;
		for (unsigned uLetter = 0; uLetter < MAX_ALPHA; ++uLetter)
			{
			const SCORE scoreMatchEmitA =
			  (SCORE) log2(PPA.m_Probs[uLetter]) - GetNullEmitScore(uLetter);
			const SCORE scoreMatchEmitB =
			  (SCORE) log2(PPB.m_Probs[uLetter]) - GetNullEmitScore(uLetter);
			Score += (SCORE) (scoreMatchEmitA*scoreMatchEmitB);
			}
		return Score;
		}
	};

#endif	// PWMDotM_h
