// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "PWMM.h"
#include <math.h>

SCORE PWMM::MMScore(const PROB probA[MAX_ALPHA], const PROB probB[MAX_ALPHA])
	{
	PROB probSum = 0;
	for (unsigned uLetter = 0; uLetter < MAX_ALPHA; ++uLetter)
		{
		const PROB probBg = GetNullEmitProb(uLetter);
		probSum += probA[uLetter]*probB[uLetter]/(probBg*probBg);
		}
	return (SCORE) log2(probSum);
	}
