// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#ifndef	PWRankP_h
#define	PWRankP_h

#include "PWBase.h"

class PWRankP : public PWBase
	{
public:
	PWRankP()
		{
		}

	virtual ~PWRankP()
		{
		}

	virtual PWCLASS GetClass() const { return PWCLASS_RankP; }

	virtual SCORE ScoreProfPos(const ProfPos &PPA, const ProfPos &PPB) const
		{
		float RanksA[MAX_ALPHA];
		float RanksB[MAX_ALPHA];
		Rank(PPA.m_Probs, RanksA, MAX_ALPHA);
		Rank(PPB.m_Probs, RanksB, MAX_ALPHA);
		return (SCORE) Correl(RanksA, RanksB, MAX_ALPHA);
		}
	};

#endif	// PWRankP_h
