// Lobster: tools for biological sequence analysis
// (C) Copyright 2002-2003 Robert C. Edgar
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANT-
// ABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
// Public License for more details.

#include "lobster.h"
#include "MSA.h"

// Compute the sum of pairs score from two pair maps. See MSAGetPairMap.cpp.
// It is the simplicity of this code that motivates the use of pair maps.
double SumPairs(const int iMapRef[], const int iMapTest[], unsigned uLength)
	{
	unsigned uPairCount = 0;
	unsigned uCorrectPairCount = 0;
	for (unsigned uPos = 0; uPos < uLength; ++uPos)
		{
		int iPosRef = iMapRef[uPos];
		if (-1 == iPosRef)
			continue;

		++uPairCount;

		int iPosTest = iMapTest[uPos];
		if (-1 == iPosTest)
			continue;

		if (iPosRef == iPosTest)
			++uCorrectPairCount;
		}

	if (0 == uPairCount)
		return 0.0;

	return (double) uCorrectPairCount / (double) uPairCount;
	}
